package com.example.domticacongestosfaciales



import android.app.AlertDialog
import androidx.fragment.app.Fragment
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.bluetooth.BluetoothSocket
import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.content.pm.PackageManager
import android.content.res.Configuration
import android.os.Build
import android.os.Bundle
import android.os.Handler
import android.os.Looper
import android.provider.SyncStateContract
import android.text.Editable
import android.text.TextWatcher
import android.util.Log
import android.util.TypedValue
import android.view.inputmethod.EditorInfo
import android.widget.Button
import android.widget.EditText
import android.widget.LinearLayout
import android.widget.Switch
import android.widget.TextView
import android.widget.Toast
import androidx.annotation.RequiresApi
import androidx.appcompat.app.AppCompatActivity
import androidx.core.app.ActivityCompat
import androidx.core.content.ContextCompat
import com.example.domticacongestosfaciales.databinding.DialogTopicsBinding
import com.example.domticacongestosfaciales.databinding.FragmentMQTTConfigBinding
import com.example.domticacongestosfaciales.sqlite.ConexionBBDDSQLite
import info.mqtt.android.service.MqttAndroidClient
import org.eclipse.paho.client.mqttv3.IMqttActionListener
import org.eclipse.paho.client.mqttv3.IMqttDeliveryToken
import org.eclipse.paho.client.mqttv3.IMqttToken
import org.eclipse.paho.client.mqttv3.MqttCallbackExtended
import org.eclipse.paho.client.mqttv3.MqttClient
import org.eclipse.paho.client.mqttv3.MqttConnectOptions
import org.eclipse.paho.client.mqttv3.MqttException
import org.eclipse.paho.client.mqttv3.MqttMessage
import java.util.UUID



class MQTTConfigFragment : Fragment() {

    private lateinit var binding: FragmentMQTTConfigBinding

    companion object {
        val TAG = "MQTT"
        var mqttClient: MqttAndroidClient?= null
        private val clientId = MqttClient.generateClientId()
        var conectado = false
        var numeroTopics = 1
        var usuarioMQTT = ""
        var contrasenaMQTT = ""
        var direccion: String = ""
        var puerto: String = ""
        var serverUri: String = ""
        var publishTopic: String = ""
        var subscriptionTopic: String = ""

        var subscriptionTopic1 = "ControlDomoticaGestosFaciales/DomoticaAAndroid1" // Cambia este tema al que estés utilizando en tu ESP32
        //var publishTopic1 = ""//"zigbee2mqtt/EnchufeGestos/set"
        var subscriptionTopic2 = "ControlDomoticaGestosFaciales/DomoticaAAndroid2"
        //var publishTopic2 = ""//"ControlDomoticaGestosFaciales/AndroidADomotica2"
        var subscriptionTopic3 = "ControlDomoticaGestosFaciales/DomoticaAAndroid3"
        //var publishTopic3 = "" //"ControlDomoticaGestosFaciales/AndroidADomotica3"
        var subscriptionTopic4 = "ControlDomoticaGestosFaciales/DomoticaAAndroid4"
        //var publishTopic4 = ""//"ControlDomoticaGestosFaciales/AndroidADomotica4"
        var subscriptionTopic5 = "ControlDomoticaGestosFaciales/DomoticaAAndroid5"
        //var publishTopic5 = ""//"ControlDomoticaGestosFaciales/AndroidADomotica5"
    }

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        binding = FragmentMQTTConfigBinding.inflate(inflater,container,false)
        return binding.root
    }


    @RequiresApi(Build.VERSION_CODES.TIRAMISU)
    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        permisos()

        numeroTopics = 1

//
        // Obtener una instancia de SharedPreferences para guardar la direccion introducida
        //val sharedPreferences = requireContext().getSharedPreferences("MiAppPreferences", Context.MODE_PRIVATE)

        // Recuperar el string almacenado y establecerlo en el editText en la siguiente ejecución de la aplicación
        //val direccionGuardada = sharedPreferences.getString("direccionGuardada", "")
        //Log.d("SharedPreferences", "Direccion guardada: $direccionGuardada")
     //   binding.editText1.setText(direccionGuardada)



///Para base de datos (GPT)
//Hace lo que sharedPreferences pero usando SQLite
        val dbHelper = ConexionBBDDSQLite(requireContext())
        //Saco el tamaño de la tabla de usuarios para mostrar luego el último introducido
        val sizeUsuarios = ConexionBBDDSQLite(requireContext()).check_t_usuarios()

        //Obtengo la direccion de la ultima fila de la table
        val dnsAntes = dbHelper.getDnsById(sizeUsuarios)
        //Si hay direccion, la pongo en el editText
        if (dnsAntes != null) {
            Log.d("DataBase", "Direccion del usuario: $dnsAntes")
            binding.editText1.setText(dnsAntes)
        } else {
            Log.d("DataBase", "Direccion no encontrada")
        }

///

        // Guardar el string en SharedPreferences cuando el usuario introduzca un texto
        binding.editText1.addTextChangedListener(object : TextWatcher {
            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
            }

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
            }

            override fun afterTextChanged(s: Editable?) {
                val texto = s.toString()
                //val editor = sharedPreferences.edit()
                //editor.putString("direccionGuardada", texto)
                //editor.apply()
                Log.d("SharedPreferences", "Direccion cambiada: $texto")
            //Para meterlo a la base de datos
                //val nombreUsuario = "eiarob"
                //ConexionBBDDSQLite(requireContext()).updateDireccion(nombreUsuario, texto)

                //ToStringOrNull devuelve el int que representa el texto si es que es válido
                ConexionBBDDSQLite(requireContext()).updateUsuario(texto, binding.editText2.text.toString().toIntOrNull()?:return, binding.editTextUsuarioMQTT.text.toString(), binding.editTextContrasenaMQTT.text.toString())
            }
        })



//Pongo esta parte antes de cada cambio de editText para que el setText esté actualizado
//Si lo pongo todos arriba como tenía antes, creo que no iría bien cada llamada a "updateUsuario"
        //Obtengo el puerto de la ultima fila de la table
        val puertoAntes = dbHelper.getPuertoById(sizeUsuarios)
        //Si hay puerto, lo pongo en el editText
        if (puertoAntes != null) {
            Log.d("DataBase", "Puerto del usuario: $puertoAntes")
            binding.editText2.setText(puertoAntes)
        } else {
            Log.d("DataBase", "Puerto no encontrado")
        }
//

        // Obtener una instancia de SharedPreferences para guardar la direccion introducida
        //val sharedPreferencesPuerto = requireContext().getSharedPreferences("PuertoPreferences", Context.MODE_PRIVATE)

        // Recuperar el string almacenado y establecerlo en el editText en la siguiente ejecución de la aplicación
        //val puertoGuardado = sharedPreferences.getString("puertoGuardado", "")
        //Log.d("SharedPreferences", "Puerto guardado: $puertoGuardado")
        //binding.editText2.setText(puertoGuardado)

        // Guardar el string en SharedPreferences cuando el usuario introduzca un texto
        binding.editText2.addTextChangedListener(object : TextWatcher {
            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
            }

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
            }

            override fun afterTextChanged(s: Editable?) {
                val texto = s.toString()
                //val editor = sharedPreferences.edit()
                //editor.putString("puertoGuardado", texto)
                //editor.apply()
                Log.d("SharedPreferences", "Puerto cambiado: $texto")
                ConexionBBDDSQLite(requireContext()).updateUsuario(binding.editText1.text.toString(), texto.toIntOrNull()?:return, binding.editTextUsuarioMQTT.text.toString(), binding.editTextContrasenaMQTT.text.toString())
            }
        })







//
        //Obtengo el nombre de la ultima fila de la table
        val userName = dbHelper.getUserNameById(sizeUsuarios)
        //Si hay nombre, lo pongo en el editText
        if (userName != null) {
            Log.d("DataBase", "Nombre del usuario: $userName")
            binding.editTextUsuarioMQTT.setText(userName)
        } else {
            Log.d("DataBase", "Nombre no encontrado")
        }
//

        // Recuperar el string almacenado y establecerlo en el editText en la siguiente ejecución de la aplicación
        //val usuarioGuardado = sharedPreferences.getString("usuarioGuardado", "")
        //Log.d("SharedPreferences", "Usuario guardado: $usuarioGuardado")
        //binding.editTextUsuarioMQTT.setText(usuarioGuardado)

        // Guardar el string en SharedPreferences cuando el usuario introduzca un texto
        binding.editTextUsuarioMQTT.addTextChangedListener(object : TextWatcher {
            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
            }

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
            }

            override fun afterTextChanged(s: Editable?) {
                val texto = s.toString()
                //val editor = sharedPreferences.edit()
                //editor.putString("usuarioGuardado", texto)
                //editor.apply()
                Log.d("SharedPreferences", "Usuario cambiado: $texto")
                ConexionBBDDSQLite(requireContext()).updateUsuario(binding.editText1.text.toString(), binding.editText2.text.toString().toIntOrNull()?:return, texto, binding.editTextContrasenaMQTT.text.toString())
            }
        })







//
        //Obtengo la contraseña de la ultima fila de la table
        val contrasenaAntes = dbHelper.getContrasenaById(sizeUsuarios)
        //Si hay contraseña, la pongo en el editText
        if (contrasenaAntes != null) {
            Log.d("DataBase", "Contraseña del usuario: $contrasenaAntes")
            binding.editTextContrasenaMQTT.setText(contrasenaAntes)
        } else {
            Log.d("DataBase", "Usuario no encontrado")
        }
//

        // Recuperar el string almacenado y establecerlo en el editText en la siguiente ejecución de la aplicación
        //val contrasenaGuardado = sharedPreferences.getString("contrasenaGuardado", "")
        //Log.d("SharedPreferences", "Contraseña guardado: $contrasenaGuardado")
        //binding.editTextContrasenaMQTT.setText(contrasenaGuardado)

        // Guardar el string en SharedPreferences cuando el usuario introduzca un texto
        binding.editTextContrasenaMQTT.addTextChangedListener(object : TextWatcher {
            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
            }

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
            }

            override fun afterTextChanged(s: Editable?) {
                val texto = s.toString()
                //val editor = sharedPreferences.edit()
                //editor.putString("contrasenaGuardado", texto)
                //editor.apply()
                Log.d("SharedPreferences", "Contraseña cambiado: $texto")
                ConexionBBDDSQLite(requireContext()).updateUsuario(binding.editText1.text.toString(), binding.editText2.text.toString().toIntOrNull()?:return, binding.editTextUsuarioMQTT.text.toString(), texto)
            }
        })



        //Obtengo el topico de la primera fila de la tabla
        val topico1Guardado = dbHelper.getTopicByPosition(1)
        //Si hay topico, lo pongo en el editText
        if (topico1Guardado != null) {
            Log.d("DataBase", "Topico1: $topico1Guardado")
            binding.editTextTopic1?.setText(topico1Guardado)
        } else {
            Log.d("DataBase", "Topico1 no encontrado")
        }

        // Guardar el string en SharedPreferences cuando el usuario introduzca un texto
        binding.editTextTopic1?.addTextChangedListener(object : TextWatcher {
            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
            }

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
            }

            override fun afterTextChanged(s: Editable?) {
                val texto = s.toString()
                //val editor = sharedPreferencesTopic.edit()
                //editor.putString("topico1Guardado", texto)
                //editor.apply()
                Log.d("SharedPreferences", "Topico1 cambiado: $texto")
                ConexionBBDDSQLite(requireContext()).updateTopic(1,texto)
            }
        })

//

        //Para poner editText con lo que haya en la base de datos
        // Rellenar los EditText existentes con datos de la base de datos
        //La forma rara del for es para excluir el primer topic, que siempre existe de por sí y para que no aparezca doble
        val topics = dbHelper.getAllTopics()
        //for (topic in topics) {
        for(i in 1 until topics.size){
            //addTopicEditText(topic)
            addTopicEditText(topics[i])
        }

        //Para añadir los nuevos editText
        binding.buttonAnadir?.setOnClickListener {

            addTopicEditText("")

//            val editText = EditText(requireActivity()).apply {
//                hint = "Nuevo Tópico en publicar:"
//                //Para ajustar el tamaño del EditText
//                layoutParams = LinearLayout.LayoutParams(
//                    LinearLayout.LayoutParams.WRAP_CONTENT,
//                    LinearLayout.LayoutParams.WRAP_CONTENT
//                ).apply {
//                    // Margen opcional alrededor del EditText
//                    setMargins(0, 8, 0, 8)
//                }
//                // Ajustar el tamaño de la letra
//                setTextSize(TypedValue.COMPLEX_UNIT_SP, 30f)
//            }
//
//            // Booleana para saber si el tópico ya se ha insertado
//            //(Para no insertar un mismo tópico más de una vez)
//            var isInserted = false
//            //Añadimos como tal el editText
//            binding.topicContainer?.addView(editText)
//
//            // Agregar TextWatcher para el nuevo EditText
//            editText.addTextChangedListener(object : TextWatcher {
//                override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {}
//
//                override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {}
//
//                override fun afterTextChanged(s: Editable?) {
////                    val texto = s.toString()
////                    val index = binding.topicContainer!!.indexOfChild(editText) + 2 // Obtener el índice del EditText en el contenedor
////                    Log.d("VARIOS TOPICS", "Indice = ${index}")
////                    ConexionBBDDSQLite(requireContext()).insert_t_topics(texto)
////                    //ConexionBBDDSQLite(requireContext()).updateTopic(index, texto)
//                }
//            })
//
////            // Agregar un EditorActionListener para detectar cuando el usuario presiona Enter o cambia el foco
////            editText.setOnEditorActionListener { _, actionId, _ ->
////                if (actionId == EditorInfo.IME_ACTION_DONE || actionId == EditorInfo.IME_ACTION_NEXT) {
////                    val texto = editText.text.toString()
////                    Log.d("VARIOS TOPICS", "Text = ${texto}")
////                    ConexionBBDDSQLite(requireContext()).insert_t_topics(texto) // Agrega el nuevo tópico a la base de datos
////                    true
////                } else {
////                    false
////                }
////            }
//
//            // Agregar un OnFocusChangeListener para detectar cuando el usuario cambia el foco
//            editText.onFocusChangeListener = View.OnFocusChangeListener { v, hasFocus ->
//                //Para la primera vez que se escribe en el editText, para insertar
//                if (!hasFocus && !isInserted) {
//                    val texto = (v as EditText).text.toString()
//                    if (texto.isNotEmpty()) {
//                        Log.d("Database", "Insertando tópico: $texto")
//                        ConexionBBDDSQLite(requireContext()).insert_t_topics(texto) // Agrega el nuevo tópico a la base de datos
//                        isInserted = true // Marcar como insertado
//                    }
//                }
//                //Por si se cambia lo escrito(para actualizar)
//                if (!hasFocus && isInserted) {
//                    val texto = (v as EditText).text.toString()
//                    val index = binding.topicContainer!!.indexOfChild(editText) + 2
//                    if (texto.isNotEmpty()) {
//                        Log.d("Database", "Insertando tópico: $texto en fila $index")
//                        ConexionBBDDSQLite(requireContext()).updateTopic(index,texto) // Agrega el nuevo tópico a la base de datos
//                    }
//                }
//            }
        }






        //En caso de que pasen cosas raras, como tópicos intermedios
        binding.buttonBorraUltimoTopic?.setOnClickListener{

            ConexionBBDDSQLite(requireContext()).deleteLastTopic()

            //Para informar al usuario
            requireActivity().runOnUiThread {
                Toast.makeText(requireContext(), "Se ha eliminado el último tópico", Toast.LENGTH_SHORT).show()
            }

            //Para reiniciar el fragmento y que se vean los cambios (solo TopicPrueba)
            val fragmentManager = requireActivity().supportFragmentManager
            val transaction = fragmentManager.beginTransaction()
            transaction.replace(R.id.fragment_container, MQTTConfigFragment())
            transaction.addToBackStack(null) // Si deseas agregar la transacción a la pila de retroceso
            transaction.commit()
        }




        //En caso de que pasen cosas raras, como tópicos intermedios
        binding.buttonResetDB?.setOnClickListener{

            //ConexionBBDDSQLite(requireContext()).deleteTable("t_Usuarios")
            ConexionBBDDSQLite(requireContext()).deleteTable("t_Topics")

            //ConexionBBDDSQLite(requireContext()).createTable_t_usuarios()
            ConexionBBDDSQLite(requireContext()).createTable_t_topics()

            if(ConexionBBDDSQLite(requireContext()).check_t_topics()==0){
                if(MainActivity().llenarTopics().size!=0){
                    MainActivity().llenarTopics().forEach {
                        ConexionBBDDSQLite(requireContext()).insert_t_topics(it)
                    }
                }
            }

            //Para informar al usuario
            requireActivity().runOnUiThread {
                Toast.makeText(requireContext(), "Se han reiniciado los tópicos", Toast.LENGTH_SHORT).show()
            }

            //Para reiniciar el fragmento y que se vean los cambios (solo TopicPrueba)
            val fragmentManager = requireActivity().supportFragmentManager
            val transaction = fragmentManager.beginTransaction()
            transaction.replace(R.id.fragment_container, MQTTConfigFragment())
            transaction.addToBackStack(null) // Si deseas agregar la transacción a la pila de retroceso
            transaction.commit()

        }















//        //Esta línea de código determina si el dispositivo es Tablet o Móvil (fundamental para el dibujado correcto y el layout)
//        val isTablet = requireContext().resources.configuration.screenLayout and Configuration.SCREENLAYOUT_SIZE_MASK >= Configuration.SCREENLAYOUT_SIZE_LARGE
//
//        binding.buttonTopics.setOnClickListener {
//            //Código para crear y mostrar la ventana emergente(AlertDialog)
//            val builder = AlertDialog.Builder(requireActivity())
//            builder.setTitle("Introduzca al menos 1 tópico para publicar")
//            //var bindingDialogTopics = DialogTopicsBinding.inflate(inflater)
//            val viewDialog = layoutInflater.inflate(R.layout.dialog_topics, null)
//
//            val topico1 = viewDialog.findViewById<EditText>(R.id.editTextTopic1)
//            //val topico2 = viewDialog.findViewById<EditText>(R.id.editTextTopic2)
//            //val topico3 = viewDialog.findViewById<EditText>(R.id.editTextTopic3)
//            //val topico4 = viewDialog.findViewById<EditText>(R.id.editTextTopic4)
//            //val topico5 = viewDialog.findViewById<EditText>(R.id.editTextTopic5)
////
//            val topicContainer = viewDialog.findViewById<LinearLayout>(R.id.topicContainer)
//            val botonAnadir = viewDialog.findViewById<Button>(R.id.buttonAnadir)
////
//            val botonFinalizar = viewDialog.findViewById<Button>(R.id.buttonFinalizar)
//
//            builder.setView(viewDialog)
//            val dialog = builder.create()
//            dialog.show()
//
//            if(isTablet)
//                dialog.getWindow()?.setLayout(1080, 1150)
//            else
//                dialog.getWindow()?.setLayout(1080, 1700)
//
//
////
//            // Obtener una instancia de SharedPreferences para guardar la direccion introducida
//            //val sharedPreferencesTopic = requireContext().getSharedPreferences("TopicPreferences", Context.MODE_PRIVATE)
//
//            // Recuperar el string almacenado y establecerlo en el editText en la siguiente ejecución de la aplicación
//            //val topico1Guardado = sharedPreferencesTopic.getString("topico1Guardado", "")
//            //topico1.setText(topico1Guardado)
//
////            //Obtengo el topico de la primera fila de la tabla
////            val topico1Guardado = dbHelper.getTopicById(1)
////            //Si hay topico, lo pongo en el editText
////            if (topico1Guardado != null) {
////                Log.d("DataBase", "Topico1: $topico1Guardado")
////                topico1.setText(topico1Guardado)
////            } else {
////                Log.d("DataBase", "Topico1 no encontrado")
////            }
////
////            // Guardar el string en SharedPreferences cuando el usuario introduzca un texto
////            topico1.addTextChangedListener(object : TextWatcher {
////                override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
////                }
////
////                override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
////                }
////
////                override fun afterTextChanged(s: Editable?) {
////                    val texto = s.toString()
////                    //val editor = sharedPreferencesTopic.edit()
////                    //editor.putString("topico1Guardado", texto)
////                    //editor.apply()
////                    Log.d("SharedPreferences", "Topico1 cambiado: $texto")
////                    ConexionBBDDSQLite(requireContext()).updateTopic(1,texto)
////                }
////            })
//
//
//
//            // Recuperar el string almacenado y establecerlo en el editText en la siguiente ejecución de la aplicación
//            //val topico2Guardado = sharedPreferencesTopic.getString("topico2Guardado", "")
//            //topico2.setText(topico2Guardado)
//
//            //Obtengo el topico de la segunda fila de la tabla
////            val topico2Guardado = dbHelper.getTopicById(2)
////            //Si hay topico, lo pongo en el editText
////            if (topico2Guardado != null) {
////                Log.d("DataBase", "Topico2: $topico2Guardado")
////                topico2.setText(topico2Guardado)
////            } else {
////                Log.d("DataBase", "Topico2 no encontrado")
////            }
////
////            // Guardar el string en SharedPreferences cuando el usuario introduzca un texto
////            topico2.addTextChangedListener(object : TextWatcher {
////                override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
////                }
////
////                override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
////                }
////
////                override fun afterTextChanged(s: Editable?) {
////                    val texto = s.toString()
////                    //val editor = sharedPreferencesTopic.edit()
////                    //editor.putString("topico2Guardado", texto)
////                    //editor.apply()
////                    Log.d("SharedPreferences", "Topico2 cambiado: $texto")
////                    ConexionBBDDSQLite(requireContext()).updateTopic(2,texto)
////                }
////            })
////
////
////
////
////            // Recuperar el string almacenado y establecerlo en el editText en la siguiente ejecución de la aplicación
////            //val topico3Guardado = sharedPreferencesTopic.getString("topico3Guardado", "")
////            //topico3.setText(topico3Guardado)
////
////            //Obtengo el topico de la tercera fila de la tabla
////            val topico3Guardado = dbHelper.getTopicById(3)
////            //Si hay topico, lo pongo en el editText
////            if (topico3Guardado != null) {
////                Log.d("DataBase", "Topico3: $topico3Guardado")
////                topico3.setText(topico3Guardado)
////            } else {
////                Log.d("DataBase", "Topico3 no encontrado")
////            }
////
////            // Guardar el string en SharedPreferences cuando el usuario introduzca un texto
////            topico3.addTextChangedListener(object : TextWatcher {
////                override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
////                }
////
////                override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
////                }
////
////                override fun afterTextChanged(s: Editable?) {
////                    val texto = s.toString()
////                    //val editor = sharedPreferencesTopic.edit()
////                    //editor.putString("topico3Guardado", texto)
////                    //editor.apply()
////                    Log.d("SharedPreferences", "Topico3 cambiado: $texto")
////                    ConexionBBDDSQLite(requireContext()).updateTopic(3,texto)
////                }
////            })
//////
////
////
////
////            // Recuperar el string almacenado y establecerlo en el editText en la siguiente ejecución de la aplicación
////            //val topico4Guardado = sharedPreferencesTopic.getString("topico4Guardado", "")
////            //topico4.setText(topico4Guardado)
////
////            //Obtengo el topico de la cuarta fila de la tabla
////            val topico4Guardado = dbHelper.getTopicById(4)
////            //Si hay topico, lo pongo en el editText
////            if (topico4Guardado != null) {
////                Log.d("DataBase", "Topico4: $topico4Guardado")
////                topico4.setText(topico4Guardado)
////            } else {
////                Log.d("DataBase", "Topico4 no encontrado")
////            }
////
////            // Guardar el string en SharedPreferences cuando el usuario introduzca un texto
////            topico4.addTextChangedListener(object : TextWatcher {
////                override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
////                }
////
////                override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
////                }
////
////                override fun afterTextChanged(s: Editable?) {
////                    val texto = s.toString()
////                    //val editor = sharedPreferencesTopic.edit()
////                    //editor.putString("topico4Guardado", texto)
////                    //editor.apply()
////                    Log.d("SharedPreferences", "Topico4 cambiado: $texto")
////                    ConexionBBDDSQLite(requireContext()).updateTopic(4,texto)
////                }
////            })
////
////
////
////
////            //val topico5Guardado = sharedPreferencesTopic.getString("topico5Guardado", "")
////            //topico5.setText(topico5Guardado)
////
////            //Obtengo el topico de la quinta fila de la tabla
////            val topico5Guardado = dbHelper.getTopicById(5)
////            //Si hay topico, lo pongo en el editText
////            if (topico5Guardado != null) {
////                Log.d("DataBase", "Topico5: $topico5Guardado")
////                topico5.setText(topico5Guardado)
////            } else {
////                Log.d("DataBase", "Topico5 no encontrado")
////            }
////
////            topico5.addTextChangedListener(object : TextWatcher {
////                override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
////                }
////
////                override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
////                }
////
////                override fun afterTextChanged(s: Editable?) {
////                    val texto = s.toString()
////                    //val editor = sharedPreferencesTopic.edit()
////                    //editor.putString("topico5Guardado", texto)
////                    //editor.apply()
////                    Log.d("SharedPreferences", "Topico5 cambiado: $texto")
////                    ConexionBBDDSQLite(requireContext()).updateTopic(5,texto)
////                }
////            })
//
////
////
//
//
//
//            botonFinalizar.setOnClickListener{
//                if(topico1.text.toString() == "")
//                    Toast.makeText(requireContext(), "Debe haber al menos un tópico para publicar", Toast.LENGTH_LONG).show()
////                else{
////                    publishTopic1 = topico1.text.toString()
////                    if(topico2.text.toString() != ""){
////                        publishTopic2 = topico2.text.toString()
////                    }
////                    if(topico3.text.toString() != ""){
////                        publishTopic3 = topico3.text.toString()
////                    }
////                    if(topico4.text.toString() != ""){
////                        publishTopic4 = topico4.text.toString()
////                    }
////                    if(topico5.text.toString() != ""){
////                        publishTopic5 = topico5.text.toString()
////                    }
////                    dialog.dismiss()
////                }
//            }
//        }

        binding.button.setOnClickListener {
            direccion = binding.editText1.text.toString()
            puerto = binding.editText2.text.toString()
            usuarioMQTT = binding.editTextUsuarioMQTT.text.toString()
            contrasenaMQTT = binding.editTextContrasenaMQTT.text.toString()


            if(direccion.isEmpty() || puerto.isEmpty()){
                Toast.makeText(requireContext(), "Los campos no pueden estar vacíos", Toast.LENGTH_SHORT).show()
            }else{
                Toast.makeText(requireContext(), "Intentando conexión", Toast.LENGTH_LONG).show()
                try{
                    serverUri = "tcp://${direccion}:${puerto}"

                    Log.d("Servidor" ,"ServerUri = ${serverUri}")

                    conexionMQTT(requireContext(),serverUri){ exitosa ->
                        if(exitosa){
                            val fragmentManager = requireActivity().supportFragmentManager
                            val transaction = fragmentManager.beginTransaction()
                            transaction.replace(R.id.fragment_container, InitialFragment())
                            transaction.addToBackStack(null) // Si deseas agregar la transacción a la pila de retroceso
                            transaction.commit()
                        } else {
                            val handler = Handler(Looper.getMainLooper())
                            handler.post {
                                Toast.makeText(requireContext(), "Conexión fallida, vuelve a intentarlo", Toast.LENGTH_LONG).show()
                            }
                        }
                    }
                } catch (e: Exception) {
                    Log.e(TAG, "Error al intentar establecer la conexión MQTT.${e.message}")
                    val handler = Handler(Looper.getMainLooper())
                    handler.post {
                        Toast.makeText(requireContext(), "Error al intentar establecer la conexión MQTT: ${e.message}", Toast.LENGTH_LONG).show()
                    }
                }
            }
        }
    }







    //Función para la creación de editText con el botón, o para reustarurar los ya existentes
    @RequiresApi(Build.VERSION_CODES.TIRAMISU)
    private fun addTopicEditText(initialText: String) {
        val editText = EditText(requireActivity()).apply {
            hint = "Nuevo Tópico en publicar:"
            setText(initialText)
            layoutParams = LinearLayout.LayoutParams(
                LinearLayout.LayoutParams.WRAP_CONTENT,
                LinearLayout.LayoutParams.WRAP_CONTENT
            ).apply {
                setMargins(0, 8, 0, 8)
            }
            setTextSize(TypedValue.COMPLEX_UNIT_SP, 30f)
        }

        //numeroTopics = numeroTopics + 1

        //var isInserted = false

        // Agregar el EditText al contenedor
        binding.topicContainer?.addView(editText)

        // Agregar un OnFocusChangeListener para detectar cuando el usuario cambia el foco
        editText.onFocusChangeListener = View.OnFocusChangeListener { v, hasFocus ->
            if (!hasFocus) {
                val texto = (v as EditText).text.toString()
                val index = binding.topicContainer!!.indexOfChild(editText) + 2
                //Al final he puesto estos 2 if y ya va, si el texto original era "", osea nada, se crea, si no, se actualiza
                if (texto.isNotEmpty() && initialText == "") {
                    Log.d("Database", "Insertando tópico: $texto")
                    ConexionBBDDSQLite(requireContext()).insert_t_topics(texto) // Agrega el nuevo tópico a la base de datos
                    //isInserted = true // Marcar como insertado
                }
                if (texto.isNotEmpty()) {
                    Log.d("Database", "Actualizando tópico: $texto en el índice $index")
                    ConexionBBDDSQLite(requireContext()).updateTopicByPosition(index, texto) // Agrega el nuevo tópico a la base de datos
            }
            //if (!hasFocus && isInserted) {
            //    val texto = (v as EditText).text.toString()
            //    val index = binding.topicContainer!!.indexOfChild(editText) + 2
//                if (texto.isNotEmpty()) {
//                    Log.d("Database", "Actualizando tópico: $texto en el índice $index")
//                    ConexionBBDDSQLite(requireContext()).updateTopic(index, texto) // Agrega el nuevo tópico a la base de datos
                    //isInserted = true // Marcar como insertado
               // }
            }
        }
    }













    private fun permisos() {

        if (ContextCompat.checkSelfPermission(
                requireContext(),
                android.Manifest.permission.INTERNET
            ) != PackageManager.PERMISSION_GRANTED
        ) {
            ActivityCompat.requestPermissions(requireActivity(), arrayOf(
                    android.Manifest.permission.ACCESS_FINE_LOCATION,
                ),
                1
            )
        } else {
            Log.d("MainActivity", "Todos los permisos concedidos ")
        }
    }


    fun conexionMQTT(context: Context, serverUri:String, callback:(Boolean)->Unit) {

        try {

            //Esto lo añado para que no se conecte 2 veces y me salgan dobles mensajes en el logcat
            desconexionMQTT()

            mqttClient = MqttAndroidClient(context, serverUri, clientId)
            mqttClient!!.setCallback(object : MqttCallbackExtended {


                /*** Entrega completa de mensajes al broker ****/
                override fun connectComplete(reconnect: Boolean, serverURI: String) {
                    if (reconnect) {
                        Log.d("Reconexion", "Reconectado")

                        // Because Clean Session is true, we need to re-subscribe
                    } else {
                        Log.d("Reconexion", "No reconectado")
                    }
                }

                /*** Perdió la conexión con el broker. ****/
                override fun connectionLost(cause: Throwable?) {
                    Log.d("ERROR","Conexión perdida")
                }


                /**** Recibir nuevos mensajes del Broker ***/
                override fun messageArrived(topic: String, message: MqttMessage) {
                    Log.d("LLEGA EL MENSAJE DEL BROKER","MENSAJE RECIBIDO")
                    Log.d("MENSAJE:",message.toString())

                    requireActivity().runOnUiThread {
                        binding.textView2.text = "Mensaje recibido: ${message.toString()}"
                    }

                }

                /*** Se llama cuando se ha completado la entrega de un mensaje y se han recibido todas las confirmaciones ***/
                override fun deliveryComplete(token: IMqttDeliveryToken) {
                    Log.d("Éxito","MENSAJE ENVIADO")
                }
            })

            /**** Opciones de conexión MQTT ***/
            val mqttConnectOptions = MqttConnectOptions()
            mqttConnectOptions.isAutomaticReconnect = true
            mqttConnectOptions.isCleanSession = false
            mqttConnectOptions.keepAliveInterval = 50
            //mqttConnectOptions.setUserName("eiarob")
            mqttConnectOptions.setUserName(usuarioMQTT)
            //mqttConnectOptions.setPassword("eiarob_SID".toCharArray())
            mqttConnectOptions.setPassword(contrasenaMQTT.toCharArray())

            //Desconectar primero BT
            BTConfigFragment().disconnect() //Para desconectar BT
            Log.d("Bluetooth","Desconectado")

            /*** Conexión con el Broker ****/
            mqttClient!!.connect(mqttConnectOptions, null, object : IMqttActionListener {

                /*** Este método se invoca cuando una acción se ha completado correctamente.***/
                @RequiresApi(Build.VERSION_CODES.TIRAMISU)
                override fun onSuccess(asyncActionToken: IMqttToken) {
                    /*** Se crea la suscripción ***/

                    Log.d("MQTT","Éxito, Conectado")

//                    /*
//                    Para asegurar que si hay topicos para publicar guardados en la DB,
//                    no haga falta entrar al alertDialog y darle al botón
//                    */
//                    val dbHelper = ConexionBBDDSQLite(requireContext())
//
//                    var topicosNoNulos = 0
//
//                    val topico1Guardado = dbHelper.getTopicById(1)
//                    if(topico1Guardado!=null){
//                        topicosNoNulos = topicosNoNulos + 1
//                    }
//                    val topico2Guardado = dbHelper.getTopicById(2)
//                    val topico3Guardado = dbHelper.getTopicById(3)
//                    val topico4Guardado = dbHelper.getTopicById(4)
//                    val topico5Guardado = dbHelper.getTopicById(5)



                    //Para la lógica de conexiones
                    conectado = true
                    InitialFragment.MQTToBT = true

                    //Asignamos los topicos de la DB a los que se publicarán

//                    var ntopics = ConexionBBDDSQLite(requireContext()).check_t_topics()
//
//                    for(i in ntopics){
//                        publishTopic = dbHelper.getTopicById(i).toString()
//                    }
//                    publishTopic1 = topico1Guardado.toString()
//                    publishTopic2 = topico2Guardado.toString()
//                    publishTopic3 = topico3Guardado.toString()
//                    publishTopic4 = topico4Guardado.toString()
//                    publishTopic5 = topico5Guardado.toString()

                    subscribeToTopicOrden(subscriptionTopic1)
                    subscribeToTopicOrden(subscriptionTopic2)
                    subscribeToTopicOrden(subscriptionTopic3)
                    subscribeToTopicOrden(subscriptionTopic4)
                    subscribeToTopicOrden(subscriptionTopic5)

                    callback(true)
                }

                /**** Este método se invoca cuando se produce un error en una acción. ****/
                override fun onFailure(asyncActionToken: IMqttToken?, exception: Throwable?) {
                    Log.d("Error MQTT","No conectado")
                    Log.d("Error MQTT",exception.toString())
                    conectado = false
                    callback(false)
                }
            })

        } catch (e: MqttException) {
            Log.e(TAG, "Error excepción la clase MqttExceptiom.")
            callback(false)
        } catch (e: Exception) {
            Log.e(TAG, "Error en la conexión MQTT.")
            callback(false)
        }
    }
    fun subscribeToTopicOrden(topicOrden: String) {
        if(mqttClient!=null){
            mqttClient!!.subscribe(topicOrden, 0, null, object : IMqttActionListener {
                override fun onSuccess(asyncActionToken: IMqttToken?) {
                    Log.d(TAG, "Suscrito correctamente  $topicOrden")
                }

                override fun onFailure(asyncActionToken: IMqttToken?, exception: Throwable?) {
                    Log.e(TAG, "Error en la Suscripción")
                }
            })
        }
    }
    //Función para desconectar(GPT)
    fun desconexionMQTT() {
        try {
            mqttClient?.disconnect(null, object : IMqttActionListener {
                override fun onSuccess(asyncActionToken: IMqttToken?) {
                    Log.d(TAG, "Desconexión exitosa")
                    conectado = false
                    mqttClient = null // Liberar la instancia de mqttClient
                }

                override fun onFailure(asyncActionToken: IMqttToken?, exception: Throwable?) {
                    Log.e(TAG, "Error al desconectar MQTT")
                }
            })
        } catch (e: MqttException) {
            Log.e(TAG, "Error al desconectar MQTT: ${e.message}")
        }
    }

}

