package com.example.domticacongestosfaciales

import android.app.AlertDialog
import android.content.Context
import android.content.res.Configuration
import android.os.Bundle
import android.util.Log
import androidx.fragment.app.Fragment
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Button
import android.widget.SeekBar
import android.widget.SeekBar.OnSeekBarChangeListener
import android.widget.Switch
import android.widget.TextView
import android.widget.Toast
import com.example.domticacongestosfaciales.databinding.FragmentUsageInfoBinding


class UsageInfoFragment : Fragment() {

    private lateinit var binding: FragmentUsageInfoBinding

    private var inactivos: Int = 9

    companion object {
        var visualizarTexto = false
        var visualizarInterfaz = false
        var visualizarTextoUmbrales = false
        var visualizarPuntos = false
        var visualizarProgreso = true
        var visualizarDaltonismo = false
        var progressBarsEnCara = false
        var visualizarFlechas = true

        var cejasEncender = true
        var cejasApagar = false
        var cejasConexion = false
        var cejasCambiar = false

        var bocaEncender = false
        var bocaApagar = true
        var bocaConexion = false
        var bocaCambiar = false

        var ojoDerEncender = false
        var ojoDerApagar = false
        var ojoDerConexion = true
        var ojoDerCambiar = false

        var ojoIzqEncender = false
        var ojoIzqApagar = false
        var ojoIzqConexion = false
        var ojoIzqCambiar = true


        var umbralCejas = 14 //Esto luego lo multiplico por 0.01 para que sea 0.14 en InitialFragment
        var umbralBoca = 8
        //var umbralPosBoca = 0.28
        //var umbralPosBoca2 = 0.31
        //var umbralPosBoca3 = 0.23
        //var umbralPosBoca4 = 0.05
        //var umbralPosBoca5 = 0.24
        var umbralOjoDer = 3
        var umbralOjoIzq = 3
    }

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        binding = FragmentUsageInfoBinding.inflate(inflater,container,false)
        return binding.root
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        //Esta línea de código determina si el dispositivo es Tablet o Móvil (para mostrar el alertDialog bien)
        val isTablet = requireContext().resources.configuration.screenLayout and Configuration.SCREENLAYOUT_SIZE_MASK >= Configuration.SCREENLAYOUT_SIZE_LARGE

        // Obtener una instancia de SharedPreferences para guardar la direccion introducida
        val preferences = requireContext().getSharedPreferences("UmbralesPreferences", Context.MODE_PRIVATE)
        val editor = preferences.edit()

        //Estos condicionales son para actualizar los textViews al volver a entrar al Fragment
        if(!visualizarTexto)
            binding.textView1.text = "VISUALIZACIÓN DE TEXTOS: DESACTIVADO"
        else
            binding.textView1.text = "VISUALIZACIÓN DE TEXTOS: ACTIVADO"

        if(!visualizarInterfaz)
            binding.textViewInterfaz.text = "VISUALIZACIÓN DE EXPLICACION ICONOS: DESACTIVADO"
        else
            binding.textViewInterfaz.text = "VISUALIZACIÓN DE EXPLICACION ICONOS: ACTIVADO"

        if(!visualizarTextoUmbrales)
            binding.textViewTextUmbral?.text = "VISUALIZACIÓN DE VALORES UMBRALES: DESACTIVADO"
        else
            binding.textViewTextUmbral?.text = "VISUALIZACIÓN DE VALORES UMBRALES: ACTIVADO"


        if(!visualizarPuntos)
            binding.textView2.text = "VISUALIZACIÓN DE PUNTOS FACIALES: DESACTIVADO"
        else
            binding.textView2.text = "VISUALIZACIÓN DE PUNTOS FACIALES: ACTIVADO"


        if(!visualizarProgreso)
            binding.textView3.text = "VISUALIZACIÓN DE BARRAS DE PROGRESO: DESACTIVADO"
        else
            binding.textView3.text = "VISUALIZACIÓN DE BARRAS DE PROGRESO: ACTIVADO"


        if(!progressBarsEnCara)
            binding.textViewProgressBarEnCara.text = "BARRAS DE PROGRESO SOBRE LA CARA: DESACTIVADO"
        else
            binding.textViewProgressBarEnCara.text = "BARRAS DE PROGRESO SOBRE LA CARA: ACTIVADO"


        if(!visualizarFlechas)
            binding.textViewFlechas.text = "VISUALIZACIÓN DE FLECHAS DE INDICACIÓN: DESACTIVADO"
        else
            binding.textViewFlechas.text = "VISUALIZACIÓN DE FLECHAS DE INDICACIÓN: ACTIVADO"


        if(!visualizarDaltonismo)
            binding.textViewDaltonismo.text = "VISUALIZACIÓN PARA DALTÓNICOS: DESACTIVADO"
        else
            binding.textViewDaltonismo.text = "VISUALIZACIÓN PARA DALTÓNICOS: ACTIVADO"



        binding.button2.setOnClickListener {
            if (visualizarTexto) {
                visualizarTexto = false
                binding.textView1.text = "VISUALIZACIÓN DE TEXTOS: DESACTIVADO"
                Toast.makeText(requireContext(), "No se visualizará el texto", Toast.LENGTH_SHORT).show()
            } else {
                visualizarTexto = true
                binding.textView1.text = "VISUALIZACIÓN DE TEXTOS: ACTIVADO"
                Toast.makeText(requireContext(), "Se visualizará el texto", Toast.LENGTH_SHORT).show()
            }
        }
        binding.buttonInterfaz.setOnClickListener {
            if (visualizarInterfaz) {
                visualizarInterfaz = false
                binding.textViewInterfaz.text = "VISUALIZACIÓN DE EXPLICACION ICONOS: DESACTIVADO"
                Toast.makeText(requireContext(), "No se visualizará la explicacion de iconos", Toast.LENGTH_SHORT).show()
            } else {
                visualizarInterfaz = true
                binding.textViewInterfaz.text = "VISUALIZACIÓN DE EXPLICACION ICONOS: ACTIVADO"
                Toast.makeText(requireContext(), "Se visualizará la explicacion de iconos", Toast.LENGTH_SHORT).show()
            }
        }
        binding.buttonTextUmbral?.setOnClickListener {
            if (visualizarTextoUmbrales) {
                visualizarTextoUmbrales = false
                binding.textViewTextUmbral?.text = "VISUALIZACIÓN DE VALORES UMBRALES: DESACTIVADO"
                Toast.makeText(requireContext(), "No se visualizarán los valores umbrales", Toast.LENGTH_SHORT).show()
            } else {
                visualizarTextoUmbrales = true
                binding.textViewTextUmbral?.text = "VISUALIZACIÓN DE VALORES UMBRALES: ACTIVADO"
                Toast.makeText(requireContext(), "Se visualizarán los valores umbrales", Toast.LENGTH_SHORT).show()
            }
        }
        binding.button3.setOnClickListener {
            if (visualizarPuntos) {
                visualizarPuntos = false
                binding.textView2.text = "VISUALIZACIÓN DE PUNTOS FACIALES: DESACTIVADO"
                Toast.makeText(requireContext(), "No se visualizarán los puntos faciales", Toast.LENGTH_SHORT).show()
            } else {
                visualizarPuntos = true
                binding.textView2.text = "VISUALIZACIÓN DE PUNTOS FACIALES: ACTIVADO"
                Toast.makeText(requireContext(), "Se visualizarán los puntos faciales", Toast.LENGTH_SHORT).show()
            }
        }
        binding.button4.setOnClickListener {
            if (visualizarProgreso) {
                visualizarProgreso = false
                binding.textView3.text = "VISUALIZACIÓN DE BARRAS DE PROGRESO: DESACTIVADO"
                Toast.makeText(requireContext(), "No se visualizarán las barras de progreso", Toast.LENGTH_SHORT).show()
            } else {
                visualizarProgreso = true
                binding.textView3.text = "VISUALIZACIÓN DE BARRAS DE PROGRESO: ACTIVADO"
                Toast.makeText(requireContext(), "Se visualizarán las barras de progreso", Toast.LENGTH_SHORT).show()
            }
        }
        binding.buttonProgressBarEnCara.setOnClickListener {
            if (progressBarsEnCara) {
                progressBarsEnCara = false
                binding.textViewProgressBarEnCara.text = "BARRAS DE PROGRESO SOBRE LA CARA: DESACTIVADO"
                Toast.makeText(requireContext(), "No se visualizarán las barras en la cara", Toast.LENGTH_SHORT).show()
            } else {
                progressBarsEnCara = true
                binding.textViewProgressBarEnCara.text = "BARRAS DE PROGRESO SOBRE LA CARA: ACTIVADO"
                Toast.makeText(requireContext(), "Se visualizarán las barras en la cara", Toast.LENGTH_SHORT).show()
            }
        }
        binding.buttonFlechas.setOnClickListener {
            if (visualizarFlechas) {
                visualizarFlechas = false
                binding.textViewFlechas.text = "VISUALIZACIÓN DE FLECHAS DE INDICACIÓN: DESACTIVADO"
                Toast.makeText(requireContext(), "No se visualizarán las flechas de indicación", Toast.LENGTH_SHORT).show()
            } else {
                visualizarFlechas = true
                binding.textViewFlechas.text = "VISUALIZACIÓN DE FLECHAS DE INDICACIÓN: ACTIVADO"
                Toast.makeText(requireContext(), "Se visualizarán las flechas de indicación", Toast.LENGTH_SHORT).show()
            }
        }
        binding.button5.setOnClickListener {
            //Código para crear y mostrar la ventana emergente(AlertDialog)
            val builder = AlertDialog.Builder(requireActivity())
            builder.setTitle("Configuración gestos")
            val viewDialog = layoutInflater.inflate(R.layout.dialog, null)

            val switch1 = viewDialog.findViewById<Switch>(R.id.switch1)
            val switch2 = viewDialog.findViewById<Switch>(R.id.switch2)
            val switchConexionCejas = viewDialog.findViewById<Switch>(R.id.switchConexionCejas)

            val switch3 = viewDialog.findViewById<Switch>(R.id.switch3)
            val switch4 = viewDialog.findViewById<Switch>(R.id.switch4)
            val switchConexionBoca = viewDialog.findViewById<Switch>(R.id.switchConexionBoca)

            val switch5 = viewDialog.findViewById<Switch>(R.id.switch5)
            val switch6 = viewDialog.findViewById<Switch>(R.id.switch6)
            val switchConexionOjoDer = viewDialog.findViewById<Switch>(R.id.switchConexionOjoDer)

            val switch7 = viewDialog.findViewById<Switch>(R.id.switch7)
            val switch8 = viewDialog.findViewById<Switch>(R.id.switch8)
            val switchConexionOjoIzq = viewDialog.findViewById<Switch>(R.id.switchConexionOjoIzq)

            val botonAceptar = viewDialog.findViewById<Button>(R.id.button6)

            val textView15 = viewDialog.findViewById<TextView>(R.id.textView15)


            //Recuperar el estado de los switches de SharedPreferences
            switch1.isChecked = preferences.getBoolean("switch1Guardado", true)
            switch2.isChecked = preferences.getBoolean("switch2Guardado", false)
            switchConexionCejas.isChecked = preferences.getBoolean("switchConexionCejasGuardado", false)
            switch3.isChecked = preferences.getBoolean("switch3Guardado", false)
            switch4.isChecked = preferences.getBoolean("switch4Guardado", true)
            switchConexionBoca.isChecked = preferences.getBoolean("switchConexionBocaGuardado", false)
            switch5.isChecked = preferences.getBoolean("switch5Guardado", false)
            switch6.isChecked = preferences.getBoolean("switch6Guardado", false)
            switchConexionOjoDer.isChecked = preferences.getBoolean("switchConexionOjoDerGuardado", true)
            switch7.isChecked = preferences.getBoolean("switch7Guardado", false)
            switch8.isChecked = preferences.getBoolean("switch8Guardado", false)
            switchConexionOjoIzq.isChecked = preferences.getBoolean("switchConexionOjoIzqGuardado", false)


            switch1.setOnCheckedChangeListener { _, isChecked ->
                if (isChecked) {
                    switch2.isChecked = false
                    switchConexionCejas.isChecked = false
                    switch3.isChecked = false
                    switch5.isChecked = false
                    switch7.isChecked = false
                    cejasEncender = true
                    inactivos = inactivos - 1
                } else {
                    cejasEncender = false
                    inactivos = inactivos + 1
                }
                editor.putBoolean("switch1Guardado",isChecked).apply()
            }
            switch2.setOnCheckedChangeListener { _, isChecked ->
                if (isChecked) {
                    switch1.isChecked = false
                    switchConexionCejas.isChecked = false
                    switch4.isChecked = false
                    switch6.isChecked = false
                    switch8.isChecked = false
                    cejasApagar = true
                    inactivos = inactivos - 1
                } else {
                    cejasApagar = false
                    inactivos = inactivos + 1
                }
                editor.putBoolean("switch2Guardado",isChecked).apply()
            }
            switchConexionCejas.setOnCheckedChangeListener { _, isChecked ->
                if (isChecked) {
                    switch1.isChecked = false
                    switch2.isChecked = false
                    switchConexionBoca.isChecked = false
                    switchConexionOjoDer.isChecked = false
                    switchConexionOjoIzq.isChecked = false
                    cejasConexion = true
                    inactivos = inactivos - 1
                } else {
                    cejasConexion = false
                    inactivos = inactivos + 1
                }
                editor.putBoolean("switchConexionCejasGuardado",isChecked).apply()
            }

            switch3.setOnCheckedChangeListener { _, isChecked ->
                if (isChecked) {
                    switch1.isChecked = false
                    switch4.isChecked = false
                    switchConexionBoca.isChecked = false
                    switch5.isChecked = false
                    switch7.isChecked = false
                    bocaEncender = true
                    inactivos = inactivos - 1
                } else {
                    bocaEncender = false
                    inactivos = inactivos + 1
                }
                editor.putBoolean("switch3Guardado",isChecked).apply()
            }
            switch4.setOnCheckedChangeListener { _, isChecked ->
                if (isChecked) {
                    switch3.isChecked = false
                    switch2.isChecked = false
                    switchConexionBoca.isChecked = false
                    switch6.isChecked = false
                    switch8.isChecked = false
                    bocaApagar = true
                    inactivos = inactivos - 1
                } else {
                    bocaApagar = false
                    inactivos = inactivos + 1
                }
                editor.putBoolean("switch4Guardado",isChecked).apply()
            }
            switchConexionBoca.setOnCheckedChangeListener { _, isChecked ->
                if (isChecked) {
                    switch3.isChecked = false
                    switch4.isChecked = false
                    switchConexionCejas.isChecked = false
                    switchConexionOjoDer.isChecked = false
                    switchConexionOjoIzq.isChecked = false
                    bocaConexion = true
                    inactivos = inactivos - 1
                } else {
                    bocaConexion = false
                    inactivos = inactivos + 1
                }
                editor.putBoolean("switchConexionBocaGuardado",isChecked).apply()
            }

            switch5.setOnCheckedChangeListener { _, isChecked ->
                if (isChecked) {
                    switch6.isChecked = false
                    switchConexionOjoDer.isChecked = false
                    switch1.isChecked = false
                    switch3.isChecked = false
                    switch7.isChecked = false
                    ojoDerEncender = true
                    inactivos = inactivos - 1
                } else {
                    ojoDerEncender = false
                    inactivos = inactivos + 1
                }
                editor.putBoolean("switch5Guardado",isChecked).apply()
            }
            switch6.setOnCheckedChangeListener { _, isChecked ->
                if (isChecked) {
                    switch5.isChecked = false
                    switch2.isChecked = false
                    switchConexionOjoDer.isChecked = false
                    switch4.isChecked = false
                    switch8.isChecked = false
                    ojoDerApagar = true
                    inactivos = inactivos - 1
                } else {
                    ojoDerApagar = false
                    inactivos = inactivos + 1
                }
                editor.putBoolean("switch6Guardado",isChecked).apply()
            }
            switchConexionOjoDer.setOnCheckedChangeListener { _, isChecked ->
                if (isChecked) {
                    switch5.isChecked = false
                    switch6.isChecked = false
                    switchConexionCejas.isChecked = false
                    switchConexionBoca.isChecked = false
                    switchConexionOjoIzq.isChecked = false
                    ojoDerConexion = true
                    inactivos = inactivos - 1
                } else {
                    ojoDerConexion = false
                    inactivos = inactivos + 1
                }
                editor.putBoolean("switchConexionOjoDerGuardado",isChecked).apply()
            }

            switch7.setOnCheckedChangeListener { _, isChecked ->
                if (isChecked) {
                    switch8.isChecked = false
                    switchConexionOjoIzq.isChecked = false
                    switch1.isChecked = false
                    switch3.isChecked = false
                    switch5.isChecked = false
                    ojoIzqEncender = true
                    inactivos = inactivos - 1
                } else {
                    ojoIzqEncender = false
                    inactivos = inactivos + 1
                }
                editor.putBoolean("switch7Guardado",isChecked).apply()
            }
            switch8.setOnCheckedChangeListener { _, isChecked ->
                if (isChecked) {
                    switch7.isChecked = false
                    switchConexionOjoIzq.isChecked = false
                    switch2.isChecked = false
                    switch4.isChecked = false
                    switch6.isChecked = false
                    ojoIzqApagar = true
                    inactivos = inactivos - 1
                } else {
                    ojoIzqApagar = false
                    inactivos = inactivos + 1
                }
                editor.putBoolean("switch8Guardado",isChecked).apply()
            }
            switchConexionOjoIzq.setOnCheckedChangeListener { _, isChecked ->
                if (isChecked) {
                    switch7.isChecked = false
                    switch8.isChecked = false
                    switchConexionCejas.isChecked = false
                    switchConexionBoca.isChecked = false
                    switchConexionOjoDer.isChecked = false
                    ojoIzqConexion = true
                    inactivos = inactivos - 1
                } else {
                    ojoIzqConexion = false
                    inactivos = inactivos + 1
                }
                editor.putBoolean("switchConexionOjoIzqGuardado",isChecked).apply()
            }


//////Intento de poner bien el cuarto gesto(el de cambiar de tópico)

/////
            builder.setView(viewDialog)
            val dialog = builder.create()
            dialog.show()
            if (isTablet)
                dialog.getWindow()?.setLayout(1080, 550)
            else
                dialog.getWindow()?.setLayout(1220, 850)

            botonAceptar.setOnClickListener {
                if (inactivos == 9)
                    dialog.dismiss()
                else
                    Toast.makeText(
                        requireContext(),
                        "Debe haber un gesto para encender, otro para apagar y otro para gestionar conexiones",
                        Toast.LENGTH_LONG
                    ).show()
            }
        }
        binding.buttonDaltonismo.setOnClickListener {
            if (visualizarDaltonismo) {
                visualizarDaltonismo = false
                binding.textViewDaltonismo.text = "VISUALIZACIÓN PARA DALTÓNICOS: DESACTIVADO"
                Toast.makeText(
                    requireContext(),
                    "Desactivado vista para daltónicos",
                    Toast.LENGTH_LONG
                ).show()
            } else {
                visualizarDaltonismo = true
                binding.textViewDaltonismo.text = "VISUALIZACIÓN PARA DALTÓNICOS: ACTIVADO"
                Toast.makeText(
                    requireContext(),
                    "Activado vista para daltónicos",
                    Toast.LENGTH_LONG
                ).show()
            }
        }
        binding.buttonUmbrales.setOnClickListener {
            //Código para crear y mostrar la ventana emergente(AlertDialog)
            val builderUmbrales = AlertDialog.Builder(requireActivity())
            builderUmbrales.setTitle("Configuración umbrales")
            val viewDialogUmbrales = layoutInflater.inflate(R.layout.dialog_umbrales, null)

            val seekBarCejas = viewDialogUmbrales.findViewById<SeekBar>(R.id.seekBarCejas)
            val valorUmbralCejas = viewDialogUmbrales.findViewById<TextView>(R.id.textViewValorUmbralCejas)
            val seekBarBoca = viewDialogUmbrales.findViewById<SeekBar>(R.id.seekBarBoca)
            val valorUmbralBoca = viewDialogUmbrales.findViewById<TextView>(R.id.textViewValorUmbralBoca)
            val seekBarOjoDer = viewDialogUmbrales.findViewById<SeekBar>(R.id.seekBarOjoDer)
            val valorUmbralOjoDer = viewDialogUmbrales.findViewById<TextView>(R.id.textViewValorUmbralOjoDer)
            val seekBarOjoIzq = viewDialogUmbrales.findViewById<SeekBar>(R.id.seekBarOjoIzq)
            val valorUmbralOjoIzq = viewDialogUmbrales.findViewById<TextView>(R.id.textViewValorUmbralOjoIzq)
            val botonAceptarUmbrales = viewDialogUmbrales.findViewById<Button>(R.id.buttonFinalizarUmbrales)


            // Función para ajustar la posición X del TextView basado en el progreso del SeekBar
            fun adjustTextViewPosition(seekBar: SeekBar, textView: TextView, progress: Int) {
                seekBar.post {
                    //val thumbOffset = seekBar.thumb.bounds.width() / 2 //Punto medio del seekBar
                    //val newX = seekBar.left + (seekBar.width - thumbOffset * 2) * progress / seekBar.max + thumbOffset - textView.width / 2
                    //textView.x = newX.toFloat() //Se modifica la posición X del textView
                    val thumbOffset = seekBar.thumb.bounds.width() / 2
                    val min = seekBar.min
                    val max = seekBar.max
                    val newX = seekBar.left + (seekBar.width - thumbOffset * 2) * (progress - min) / (max - min) + thumbOffset - textView.width / 2
                    textView.x = newX.toFloat()
                }
            }

            // Recuperar el string almacenado y establecerlo en el editText en la siguiente ejecución de la aplicación
//            val umbralCejasGuardado = preferences.getInt("umbralCejasGuardado", 14)
//            Log.d("preferences", "Umbral cejas guardado: $umbralCejasGuardado")
//            seekBarCejas.progress = umbralCejasGuardado

            seekBarCejas.progress = preferences.getInt("umbralCejasGuardado", 14)
            Log.d("preferences", "Umbral cejas guardado: ${seekBarCejas.progress}")
            seekBarBoca.progress = preferences.getInt("umbralBocaGuardado", 8)
            seekBarOjoDer.progress = preferences.getInt("umbralOjoDerGuardado", 3)
            seekBarOjoIzq.progress = preferences.getInt("umbralOjoIzqGuardado", 3)


            //Para que aparezcan los textViews ya en el centro y no a la izquierda
            adjustTextViewPosition(seekBarCejas, valorUmbralCejas, seekBarCejas.progress)
            //Para que aparezcan con el texto del umbral actual y no con 14, 8 o 3
            valorUmbralCejas.text = seekBarCejas.progress.toString()
            adjustTextViewPosition(seekBarBoca, valorUmbralBoca, seekBarBoca.progress)
            valorUmbralBoca.text = seekBarBoca.progress.toString()
            adjustTextViewPosition(seekBarOjoDer, valorUmbralOjoDer, seekBarOjoDer.progress)
            valorUmbralOjoDer.text = seekBarOjoDer.progress.toString()
            adjustTextViewPosition(seekBarOjoIzq, valorUmbralOjoIzq, seekBarOjoIzq.progress)
            valorUmbralOjoIzq.text = seekBarOjoIzq.progress.toString()


            seekBarCejas.setOnSeekBarChangeListener(object: SeekBar.OnSeekBarChangeListener{
                override fun onProgressChanged(seekBar: SeekBar?, progress: Int, fromUser: Boolean) {
                    umbralCejas = progress
                    preferences.edit().putInt("umbralCejasGuardado",progress).apply()
                    Log.d("preferences", "Umbral cejas cambiado: $progress")
                    valorUmbralCejas.text = progress.toString()
                    adjustTextViewPosition(seekBar!!, valorUmbralCejas, progress)
                }

                override fun onStartTrackingTouch(seekBar: SeekBar?) {
                    //Hace falta poner las 3 funciones
                }

                override fun onStopTrackingTouch(seekBar: SeekBar?) {
                    //Hace falta poner las 3 funciones, si no, da error
                }
            })

            seekBarBoca.setOnSeekBarChangeListener(object: SeekBar.OnSeekBarChangeListener{
                override fun onProgressChanged(seekBar: SeekBar?, progress: Int, fromUser: Boolean) {
                    umbralBoca = progress
                    preferences.edit().putInt("umbralBocaGuardado",progress).apply()
                    valorUmbralBoca.text = progress.toString()
                    adjustTextViewPosition(seekBar!!, valorUmbralBoca, progress)
                }

                override fun onStartTrackingTouch(seekBar: SeekBar?) {
                    //Hace falta poner las 3 funciones
                }

                override fun onStopTrackingTouch(seekBar: SeekBar?) {
                    //Hace falta poner las 3 funciones, si no, da error
                }
            })

            seekBarOjoDer.setOnSeekBarChangeListener(object: SeekBar.OnSeekBarChangeListener{
                override fun onProgressChanged(seekBar: SeekBar?, progress: Int, fromUser: Boolean) {
                    umbralOjoDer = progress
                    preferences.edit().putInt("umbralOjoDerGuardado",progress).apply()
                    valorUmbralOjoDer.text = progress.toString()
                    adjustTextViewPosition(seekBar!!, valorUmbralOjoDer, progress)
                }

                override fun onStartTrackingTouch(seekBar: SeekBar?) {
                    //Hace falta poner las 3 funciones
                }

                override fun onStopTrackingTouch(seekBar: SeekBar?) {
                    //Hace falta poner las 3 funciones, si no, da error
                }
            })
            seekBarOjoIzq.setOnSeekBarChangeListener(object: SeekBar.OnSeekBarChangeListener{
                override fun onProgressChanged(seekBar: SeekBar?, progress: Int, fromUser: Boolean) {
                    umbralOjoIzq = progress
                    preferences.edit().putInt("umbralOjoIzqGuardado",progress).apply()
                    valorUmbralOjoIzq.text = progress.toString()
                    adjustTextViewPosition(seekBar!!, valorUmbralOjoIzq, progress)
                }

                override fun onStartTrackingTouch(seekBar: SeekBar?) {
                    //Hace falta poner las 3 funciones
                }

                override fun onStopTrackingTouch(seekBar: SeekBar?) {
                    //Hace falta poner las 3 funciones, si no, da error
                }
            })


            builderUmbrales.setView(viewDialogUmbrales)
            val dialogUmbrales = builderUmbrales.create()
            dialogUmbrales.show()
            if (isTablet)
                dialogUmbrales.getWindow()?.setLayout(1200, 875)
            else
                dialogUmbrales.getWindow()?.setLayout(1100, 1050)

            botonAceptarUmbrales.setOnClickListener {
                dialogUmbrales.dismiss()
            }
        }
    }
}
