package com.example.domticacongestosfaciales.sqlite

import android.annotation.SuppressLint
import android.content.ContentValues
import android.content.Context
import android.database.Cursor
import android.database.sqlite.SQLiteCantOpenDatabaseException
import android.database.sqlite.SQLiteDatabase
import android.database.sqlite.SQLiteException
import android.database.sqlite.SQLiteOpenHelper
import android.os.Build
import android.os.Environment
import android.util.Log
import androidx.annotation.RequiresApi
import androidx.appcompat.app.AppCompatActivity
import com.example.domticacongestosfaciales.utils.Constants
import info.mqtt.android.service.MqttAndroidClient
import org.eclipse.paho.client.mqttv3.*
import java.util.*


//var arrayTipoEstancia: ArrayList<ModeloTipoEstancia> = ArrayList()
val DATABASE_VERSION = 1
val DATABASE_NAME = "eiarob.db"

//var mqttClient= MyNotification.getAppMQTT()

@RequiresApi(Build.VERSION_CODES.TIRAMISU)
class ConexionBBDDSQLite(context: Context) : SQLiteOpenHelper(context, Constants.RUTA_SQLITE, null, 2) {


    val TAG = "ConexionBBDDSQLite"

    val NOMBREARCHIVOCONFIGURACION="archivoConfiguracionEiarob.json"
    //    private val RUTACONFIGURACION: String = Environment.getExternalStorageDirectory().getAbsolutePath() + "/Configuracion"
    private val RUTACONFIGURACION: String =  Environment.getExternalStoragePublicDirectory(
        Environment.DIRECTORY_DOWNLOADS).toString()

    /***    DIALOG DE IP NUC ***/

    override fun onCreate(db: SQLiteDatabase?) {

    }



    override fun onUpgrade(db: SQLiteDatabase?, p1: Int, p2: Int) {

    }


    /**** ***************************** Funciones de tablas SQLite ***********************************/

    /**** ***************************** Funciones crear tabla ***********************************/

//Tabla de usuarios, en la que se mete direccion, puerto, usuario y contraseña
    fun createTable_t_usuarios(){

        try{
            val db: SQLiteDatabase = this.writableDatabase

            val create_t_usuarios="CREATE TABLE IF NOT EXISTS  t_Usuarios (id Integer PRIMARY KEY AUTOINCREMENT," +
                    " dns TEXT, puerto Integer, nombre TEXT, contrasena TEXT)  "

            db!!.execSQL(create_t_usuarios)

        }catch (e: SQLiteException){
            Log.e(TAG, "Error al crear la tabla,t_usuarios ")
        }
    }
//

//Tabla de la database para topics
    fun createTable_t_topics(){

        try{
            val db: SQLiteDatabase = this.writableDatabase


            val create_t_topics="CREATE TABLE IF NOT EXISTS  t_Topics (id Integer PRIMARY KEY AUTOINCREMENT," +
                    " topic TEXT, nota TEXT) "

            db!!.execSQL(create_t_topics)

        }catch (e: SQLiteException){
            Log.e(TAG, "Error al crear la tabla,t_topics ")
        }
    }





    /*******************************************   Sentencias y consultas  *************************************************/





    /************************************** Insetar y Actualizar en las Tablas SQLite ********************************************/
    /*****************************************************************************************************************************/


    /***
     * Método insertar para insertar en la tabla t_UsuarioTablet
     * @param idTablet
     * @param nombreUsuario
     */
    fun insert_t_usuarios(dns: String, puerto: Int, nombre: String, contrasena: String){//?, puerto: Int, nombre: String, contrasena: String) {
        try {
            val datos = ContentValues();
            //Le digo que me de un acceso a esa BBDD en modo escritura
            var db = this.writableDatabase

            //Voy indicando el nombre del campo y el valor.

            datos.put("dns", dns)
            datos.put("puerto", puerto)
            datos.put("nombre", nombre)
            datos.put("contrasena", contrasena)

            db.insert("t_usuarios", null, datos)

            //Cerrar conexión
            //db.close()

        } catch (ex: SQLiteException) {
            Log.e(TAG, "Error al introducir datos en la tabla t_usuarios . " + ex.message)
        }
        catch (ex: Exception) {
            Log.e(
                TAG,
                "Error genérico en la tabla t_usuarios " + ex.message
            )
        }
    }



    fun insert_t_topics( recordatorio: String?) {
        try {
            val datos = ContentValues();
            //Le digo que me de un acceso a esa BBDD en modo escritura
            var db = this.writableDatabase

            //Voy indicando el nombre del campo y el valor.

            datos.put("topic", recordatorio)

            db.insert("t_topics", null, datos)

            //Cerrar conexión
            //db.close()


        } catch (ex: SQLiteException) {
            Log.e(TAG, "Error al introducir datos en la tabla t_topics . " + ex.message)
        }
        catch (ex: Exception) {
            Log.e(
                TAG,
                "Error genérico en la tabla t_topics " + ex.message
            )
        }
    }









//PAra actualizar solamente la direccion
    //SE actualiza según el nombre, debería cambiarlo
    fun updateDireccion(nombre: String, nuevaDireccion: String): Boolean {
        val db = this.writableDatabase
        val contentValues = ContentValues()
        contentValues.put("dns", nuevaDireccion)
        val result = db.update("t_usuarios", contentValues, "nombre = ?", arrayOf(nombre))
        db.close()
        return result > 0
    }



//ESTA ES SIN NOMBRE Y PARA ACTUALIZAR TODAS LAS PARTES
    fun updateUsuario(nuevaDireccion: String, nuevoPuerto: Int, nuevoNombre: String, nuevaContrasena: String): Boolean {
        val db = this.writableDatabase
        val contentValues = ContentValues()
        contentValues.put("dns", nuevaDireccion)
        contentValues.put("puerto", nuevoPuerto)
        contentValues.put("nombre", nuevoNombre)
        contentValues.put("contrasena", nuevaContrasena)

        // Aquí se asume que estás actualizando la dirección del primer usuario encontrado en la tabla
        val result = db.update("t_usuarios", contentValues, null, null)
        db.close()
        return result > 0
    }


    fun updateTopic(id: Int, nuevoTopic: String): Boolean {
        val db = this.writableDatabase
        val contentValues = ContentValues()
        contentValues.put("topic", nuevoTopic)
        val result = db.update("t_topics", contentValues, "id = ?", arrayOf(id.toString()))
        db.close()
        return result > 0
    }
    //La ha hecho GPT para que actualice bien por posicion y no id
    @SuppressLint("Range")
    fun updateTopicByPosition(position: Int, nuevoTopic: String): Boolean {
        val db = this.writableDatabase
        val adjustedPosition = position - 1 // Ajuste para manejar posiciones desde 1 en lugar de 0
        val query = "SELECT id FROM t_topics ORDER BY id LIMIT 1 OFFSET ?"
        val cursor = db.rawQuery(query, arrayOf(adjustedPosition.toString()))
        var topicId: Int? = null
        if (cursor.moveToFirst()) {
            topicId = cursor.getInt(cursor.getColumnIndex("id"))
        }
        cursor.close()
        if (topicId != null) {
            val contentValues = ContentValues()
            contentValues.put("topic", nuevoTopic)
            val result = db.update("t_topics", contentValues, "id = ?", arrayOf(topicId.toString()))
            db.close()
            return result > 0
        }
        db.close()
        return false
    }

    //TEcnicamente la debería meter debajo, pero como la ha hecho GPT la dejo aqui
    fun getAllTopics(): List<String> {
        val topics = mutableListOf<String>()
        val db = this.readableDatabase
        val cursor = db.rawQuery("SELECT topic FROM t_topics", null)
        if (cursor.moveToFirst()) {
            do {
                topics.add(cursor.getString(cursor.getColumnIndexOrThrow("topic")))
            } while (cursor.moveToNext())
        }
        cursor.close()
        db.close()
        return topics
    }







    /************************************************** Consultas ****************************************/

    /***
     * Método para consultar si existe algún acontecimiento
     */
    @SuppressLint("Range")
    fun check_t_usuarios(): Int{

        var  devNumber=-1
        try {
            val db= this.readableDatabase

            val cursor: Cursor = db.rawQuery("SELECT COUNT(*) FROM t_usuarios", null)
            /*** Posicionarnos al principio del curso *****/
            if (cursor.moveToFirst()) {
                do {

                    devNumber=  cursor.getInt(0)

                } while (cursor.moveToNext())
            }
            //Cerrar conexión
            //db.close()

        }catch (ex: SQLiteCantOpenDatabaseException){
            Log.e(TAG, "Error 1  al consultar en SQLite check_t_usuarios . " + ex.message)

        }catch (ex: Exception){
            Log.e(TAG, "Error 2 al consultar en SQLitet_usuarios ." + ex.message)
        }

        return devNumber
    }

    @SuppressLint("Range")
    fun check_t_topics(): Int{

        var  devNumber=-1
        try {
            val db= this.readableDatabase

            val cursor: Cursor = db.rawQuery("SELECT COUNT(*) FROM t_topics  ", null)
            /*** Posicionarnos al principio del curso *****/
            if (cursor.moveToFirst()) {
                do {

                    devNumber=  cursor.getInt(0)

                } while (cursor.moveToNext())
            }

            //Cerrar conexión
            //db.close()

        }catch (ex: SQLiteCantOpenDatabaseException){
            Log.e(TAG, "Error 1  al consultar en SQLite check_t_topics . " + ex.message)

        }catch (ex: Exception){
            Log.e(TAG, "Error 2 al consultar en SQLitet_topics ." + ex.message)
        }

        return devNumber
    }


    /***
     * Método para llenar spinner con los recordatorios por defecto
     */
    @SuppressLint("Range")
    fun consultaLlenarSpinnerTopics():ArrayList<String>{
        var listaTopics: ArrayList<String> = ArrayList()
        try {
            val db= this.readableDatabase

            val cursor: Cursor = db.rawQuery("SELECT DISTINCT\n" +
                    "    t_Topics.recordatorio\n" +
                    "FROM\n" +
                    "     t_Topics ", null)

            /*** Posicionarnos al principio del curso *****/
            if (cursor.moveToFirst()) {
                do {
                    listaTopics.add(cursor.getString(cursor.getColumnIndex("recordatorio")))
                } while (cursor.moveToNext())
            }

            //Cerrar conexión
//            db.close()

        }catch (ex: SQLiteCantOpenDatabaseException){
            Log.e(TAG, "Error 1  al consultar en SQLite consulta idTratamientoUsuario. " + ex.message)

        }catch (ex: Exception){
            Log.e(TAG, "Error 2 al consultar en SQLite consulta idTratamientoUsuario." + ex.message)
        }
        return listaTopics
    }



    /***
     * Método para llenar spinner con los recordatorios por defecto
     */
    @SuppressLint("Range")
//    fun queryCalendarEvent():ArrayList<Modelo_t_RecordatorioCalendar>{
//        var listaRecordatorioCalendar: ArrayList<Modelo_t_RecordatorioCalendar> = ArrayList()
//        try {
//            val db= this.readableDatabase
//
//            val cursor: Cursor = db.rawQuery("SELECT t_RecordatorioCalendar.recordatorio, t_RecordatorioCalendar.nota, t_RecordatorioCalendar.fecha_hora FROM t_RecordatorioCalendar", null)
//
//            /*** Posicionarnos al principio del curso *****/
//            if (cursor.moveToFirst()) {
//                do {
//                    listaRecordatorioCalendar.add(Modelo_t_RecordatorioCalendar(cursor.getString(0), cursor.getString(1),cursor.getString(2)))
//                } while (cursor.moveToNext())
//            }
//
//            //Cerrar conexión
////            db.close()
//
//        }catch (ex: SQLiteCantOpenDatabaseException){
//            Log.e(TAG, "Error 1  al consultar en SQLite consulta fecha para la alarma. " + ex.message)
//
//        }catch (ex: Exception){
//            Log.e(TAG, "Error 2 al consultar en SQLite consulta fecha para la alarma." + ex.message)
//        }
//
//        return listaRecordatorioCalendar
//    }

    //@SuppressLint("Range")
    fun queryAlarmDay():ArrayList<String>{
        var listaTopics: ArrayList<String> = ArrayList()
        try {
            val db= this.readableDatabase

            val cursor: Cursor = db.rawQuery("SELECT  t_RecordatorioCalendar.fecha FROM    t_RecordatorioCalendar", null)

            /*** Posicionarnos al principio del curso *****/
            if (cursor.moveToFirst()) {
                do {
                    listaTopics.add(cursor.getString(cursor.getColumnIndex("fecha")))
                } while (cursor.moveToNext())
            }

            //Cerrar conexión
//            db.close()

        }catch (ex: SQLiteCantOpenDatabaseException){
            Log.e(TAG, "Error 1  al consultar en SQLite consulta fecha para la alarma. " + ex.message)

        }catch (ex: Exception){
            Log.e(TAG, "Error 2 al consultar en SQLite consulta fecha para la alarma." + ex.message)
        }

        return listaTopics
    }











    //Función para eliminar el último tópico(GPT)
    fun deleteLastTopic() {
        val db = this.writableDatabase

        // Consulta para obtener el ID de la última fila (mayor ID)
        val query = "SELECT id FROM t_topics ORDER BY id DESC LIMIT 1"
        val cursor = db.rawQuery(query, null)

        if (cursor.moveToFirst()) {
            val lastId = cursor.getInt(cursor.getColumnIndexOrThrow("id"))
            val rowsDeleted = db.delete("t_topics", "id = ?", arrayOf(lastId.toString()))

            if (rowsDeleted > 0) {
                Log.d(TAG, "Última fila con id $lastId eliminada")
            } else {
                Log.d(TAG, "No se pudo eliminar la fila con id $lastId")
            }
        } else {
            Log.d(TAG, "No se encontró ninguna fila para eliminar")
        }

        cursor.close()
        db.close()
        //Otro código que me dio GPT cuando me daba error lo de añadir nuevos tópicos
//        val db = this.writableDatabase
//        val query = "DELETE FROM t_topics WHERE id = (SELECT MAX(id) FROM t_topics)"
//        try {
//            db.execSQL(query)
//            Log.d(TAG, "Último tópico eliminado correctamente")
//        } catch (ex: SQLiteException) {
//            Log.e(TAG, "Error al eliminar el último tópico: " + ex.message)
//        } finally {
//            db.close()
//        }
    }


    //Para eliminar una tabla completa
    fun deleteTable(nameTable: String) {
        val db: SQLiteDatabase = this.writableDatabase
        db.execSQL("DROP TABLE IF EXISTS $nameTable")
        db.close()
    }










    /***
     * Método par comprobar que no es duplican los datos.
     */
    fun comprobarDuplicar(): Int{

        val db: SQLiteDatabase =this.readableDatabase
        val cuenta= db.rawQuery("SELECT * FROM estanciascoordenadas ", null).count

        Log.e("cuenta ----------- " , cuenta.toString())

        return cuenta
    }




/*
Funciones para sacar los campos de la base de datos del usuario
 */
    @SuppressLint("Range")
    fun getDnsById(id: Int): String? {
        var dnsDireccion: String? = null
        try {
            val db = this.readableDatabase
            val cursor: Cursor = db.rawQuery("SELECT dns FROM t_Usuarios WHERE id = ?", arrayOf(id.toString()))
            if (cursor.moveToFirst()) {
                dnsDireccion = cursor.getString(cursor.getColumnIndex("dns"))
            }
            cursor.close()
        } catch (ex: SQLiteCantOpenDatabaseException) {
            Log.e(TAG, "Error 1  al consultar en SQLite getDnsById. " + ex.message)
        } catch (ex: Exception) {
            Log.e(TAG, "Error 2 al consultar en SQLite getDnsById." + ex.message)
        }
        return dnsDireccion
    }

    @SuppressLint("Range")
    fun getPuertoById(id: Int): String? {
        var puertoObtenido: String? = null
        try {
            val db = this.readableDatabase
            val cursor: Cursor = db.rawQuery("SELECT puerto FROM t_Usuarios WHERE id = ?", arrayOf(id.toString()))
            if (cursor.moveToFirst()) {
                puertoObtenido = cursor.getString(cursor.getColumnIndex("puerto"))
            }
            cursor.close()
        } catch (ex: SQLiteCantOpenDatabaseException) {
            Log.e(TAG, "Error 1  al consultar en SQLite getPuertoById. " + ex.message)
        } catch (ex: Exception) {
            Log.e(TAG, "Error 2 al consultar en SQLite getPuertoById." + ex.message)
        }
        return puertoObtenido
    }

    @SuppressLint("Range")
    fun getUserNameById(id: Int): String? {
        var userName: String? = null
        try {
            val db = this.readableDatabase
            val cursor: Cursor = db.rawQuery("SELECT nombre FROM t_Usuarios WHERE id = ?", arrayOf(id.toString()))
            if (cursor.moveToFirst()) {
                userName = cursor.getString(cursor.getColumnIndex("nombre"))
            }
            cursor.close()
        } catch (ex: SQLiteCantOpenDatabaseException) {
            Log.e(TAG, "Error 1  al consultar en SQLite getUserNameById. " + ex.message)
        } catch (ex: Exception) {
            Log.e(TAG, "Error 2 al consultar en SQLite getUserNameById." + ex.message)
        }
        return userName
    }

    @SuppressLint("Range")
    fun getContrasenaById(id: Int): String? {
        var contrasenaObtenida: String? = null
        try {
            val db = this.readableDatabase
            val cursor: Cursor = db.rawQuery("SELECT contrasena FROM t_Usuarios WHERE id = ?", arrayOf(id.toString()))
            if (cursor.moveToFirst()) {
                contrasenaObtenida = cursor.getString(cursor.getColumnIndex("contrasena"))
            }
            cursor.close()
        } catch (ex: SQLiteCantOpenDatabaseException) {
            Log.e(TAG, "Error 1  al consultar en SQLite getContrasenaById. " + ex.message)
        } catch (ex: Exception) {
            Log.e(TAG, "Error 2 al consultar en SQLite getContrasenaById." + ex.message)
        }
        return contrasenaObtenida
    }






/*
Funciones para sacar los campos de la base de datos del usuario
 */
    @SuppressLint("Range")
    fun getTopicById(id: Int): String? {
        var topicDireccion: String? = null
        try {
            val db = this.readableDatabase
            val cursor: Cursor = db.rawQuery("SELECT topic FROM t_Topics WHERE id = ?", arrayOf(id.toString()))
            if (cursor.moveToFirst()) {
                topicDireccion = cursor.getString(cursor.getColumnIndex("topic"))
            }
            cursor.close()
        } catch (ex: SQLiteCantOpenDatabaseException) {
            Log.e(TAG, "Error 1  al consultar en SQLite getTopicById. " + ex.message)
        } catch (ex: Exception) {
            Log.e(TAG, "Error 2 al consultar en SQLite getTopicById." + ex.message)
        }
        return topicDireccion
    }

    //Intento de que vaya bien lo de insertar nuevos topics tras borrar otros
    @SuppressLint("Range")
    fun getTopicByPosition(position: Int): String? {
        var topic: String? = null
        try {
            val db = this.readableDatabase
            // Ajustar el índice de posición para que 1 corresponda al primer tópico
            val adjustedPosition = position - 1
            val query = "SELECT topic FROM t_topics ORDER BY id LIMIT 1 OFFSET ?"
            val cursor = db.rawQuery(query, arrayOf(adjustedPosition.toString()))
            if (cursor.moveToFirst()) {
                topic = cursor.getString(cursor.getColumnIndex("topic"))
            }
            cursor.close()
        } catch (ex: SQLiteCantOpenDatabaseException) {
            Log.e(TAG, "Error al consultar en SQLite getTopicByPosition. " + ex.message)
        } catch (ex: Exception) {
            Log.e(TAG, "Error al consultar en SQLite getTopicByPosition." + ex.message)
        }
        return topic
    }


  }